package renzhengshouquan

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/aaa"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/renzhengshouquan/model"
)

type profile struct {
	Auth
	order      string `data:"3"`
	modify     string `name:"modify info" role:"leader,worker"`
	upload     string `name:"upload" role:"leader,worker"`
	authList   string `name:"authList" role:"void"`
	memberList string `name:"memberList" role:"void"`
	systemList string `name:"systemList" role:"void"`
}

func (s profile) Modify(m *ice.Message, arg ...string) {
	s.Update(m, kit.Dict(m.OptionSimple(model.INFO)), model.UID, m.Option(model.AUTH_UID))
}
func (s profile) Upload(m *ice.Message, arg ...string) {
	m.WarnNotValid(!kit.IsIn(m.OptionDefault(mdb.FIELD, aaa.AVATAR), aaa.AVATAR, aaa.BACKGROUND))
	s.Table.UploadUpdate(m, "", m.Option(model.AUTH_UID))
}
func (s profile) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		s.Select(m, model.UID, arg[0])
		kit.If(s.IsVisitor(m), func() { m.Action() }, func() { m.Action(s.Modify) })
	}
	s.RewriteAppend(m)
	m.Display("")
}
func (s profile) AuthList(m *ice.Message, arg ...string) {
	m.Cmdy(s.Auth, m.Option(model.AUTH_UID)).Table(func(value ice.Maps) {
		if value[model.SERVICE_UID] == "" {
			m.PushButton()
		} else {
			m.PushButton(s.Enter)
		}
	})
	s.SelectJoinService(m)
	s.RewriteAppend(m)
}
func (s profile) MemberList(m *ice.Message, arg ...string) {
	msg := s.Select(m.Spawn(), model.UID, m.Option(model.AUTH_UID))
	service := s.ServiceList(m, msg.Append(model.PLACE_UID), msg.Append(model.SERVICE_UID))
	m.Cmdy(web.SPACE, service.Append(model.SPACE), service.Append(model.INDEX), m.ActionKey(), msg.Append(model.PLACE_UID))
	s.RewriteAppend(m)
}
func (s profile) SystemList(m *ice.Message, arg ...string) {
	list := s.SettingProfile(m.Spawn(), arg...).Appendv(model.PLACE_UID)
	s.FieldsWithCreatedAT(m, s.Auth, kit.TransArgs(kit.Split(m.Config(mdb.FIELDS), ",", ","))...)
	s.SelectList(m, kit.Simple(model.PLACE_UID, kit.Sort(list))...)
	s.SelectJoinService(m).PushAction(s.Enter)
	s.RewriteAppend(m)
}
func (s profile) Enter(m *ice.Message, arg ...string) {
}

func init() { ice.TeamCtxCmd(profile{}) }
